class OrderItemSlimPdf < Prawn::Document
  include ActionView::Helpers::NumberHelper
  attr_accessor :label_width,:price_column_width,:page_width, :page_height, :margin, :price_width, :item_width, :header_font_size, :item_font_size,:item_height,:qty_width,:total_width,:item_description_width
  def initialize(print_settings,order_item_slim, print_status, options, alt_name)
    self.page_width = print_settings.page_width
    self.page_height = print_settings.page_height
    self.margin = 0
    self.price_width = 40 # No Need for item
    self.qty_width = 40
    self.total_width = 40  # No Need for item
    self.item_width = self.page_width - (self.qty_width - self.margin)
    self.item_height = 15   
    self.item_description_width = self.page_width - (self.price_width + self.qty_width + self.total_width)
    self.label_width=90   

    super(:margin => [print_settings.heading_space, self.margin, self.margin, self.margin], :page_size => [self.page_width, self.page_height])
    # super(:margin => [10, 5, 30, 5], :page_size => [200,400])

    # db font setup
    if print_settings.font != ""
        font_families.update("#{print_settings.font}" => {
            :normal => "public/fonts/#{print_settings.font}.ttf",
            :italic => "public/fonts/#{print_settings.font}.ttf",
            :bold => "public/fonts/#{print_settings.font}.ttf",
            :bold_italic => "public/fonts/#{print_settings.font}.ttf"
        })

        font "#{print_settings.font}"
        fallback_fonts ["Courier", "Helvetica", "Times-Roman"]  

        self.header_font_size = 11
        self.item_font_size = 9
    else
        self.header_font_size = 12
        self.item_font_size = 10       
    end
     # font "public/fonts/Zawgyi-One.ttf"
     # font "public/fonts/padauk.ttf"  
     #font "public/fonts/Chinese.ttf"     

    text "#{ order_item_slim.type + '-' + order_item_slim.dining + print_status }", :size => self.header_font_size,:align => :center, :left_margin => -20
    stroke_horizontal_rule
    move_down 1

    #order_info
    order_info(order_item_slim.order_id, order_item_slim.order_by,order_item_slim.order_at)

    # order items slim
    order_items_slim(order_item_slim, options, alt_name, print_settings.precision)
  end

  # Write Order Information to PDF
  def order_info(order_no, order_by, order_at)  
    y_position = cursor
    bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
        text "OrderNo: #{order_no} ", :size => self.item_font_size,:align => :left    
    end

    move_down 1
    y_position = cursor
    bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
        text "OrderBy: #{order_by} ", :size => self.item_font_size,:align => :left    
    end

    move_down 1
    y_position = cursor
    bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
        text "Date: #{order_at.utc.getlocal.strftime("%Y-%m-%d %I:%M %p")}", :size => self.item_font_size,:align => :left    
    end

    stroke_horizontal_rule

    move_down 3
  end

  # Write Order items to PDF
  def order_items_slim(order_item_slim, options, alt_name, precision)
    y_position = cursor

    #Add Order Item    
    add_order_items_slim(order_item_slim, options, alt_name, precision)

    dash(1, :space => 1, :phase => 1)
    stroke_horizontal_line 0, (self.page_width - self.margin)
    move_down 1
  end

  # Add order items slim under order info
  def add_order_items_slim(order_item_slim, options, alt_name, precision)
    y_position = cursor

    move_down 1

    bounding_box([0,y_position], :width => self.item_width) do
        text "#{order_item_slim.item_name}", :size => self.item_font_size,:align => :left
    end

    bounding_box([self.item_width,y_position], :width => self.qty_width) do
        text "[#{number_with_precision(order_item_slim.qty.to_i, :precision => precision.to_i)}]", :size => self.item_font_size,:align => :left
    end

    bounding_box([0,y_position], :width => self.item_width) do
      text "#{order_item_slim.item_name}", :size => self.item_font_size,:align => :left

    end

    # if alt_name
    #     if !(order_item_slim.alt_name).empty?
    #         move_down 1
    #         font("public/fonts/NotoSansCJKtc-Regular.ttf") do
    #             text "(#{order_item_slim.alt_name})", :size => self.item_font_size,:align => :left, :inline_format => true
    #         end
    #     end
    # end

    if !options.empty?
        move_down 1

        # add option
        y_position = cursor
        bounding_box([0,y_position], :width => self.item_width, :height => self.item_height) do
            text "#{options}", :size => self.item_font_size,:align => :left
        end
    end
    move_down 1

  end

end
